/**
 * produitFiche
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * API version: 1
 * 
 *
 */

/* tslint:disable:no-unused-variable member-ordering */

import {AxiosInstance, AxiosResponse}                        from 'axios'

import * as models                                           from '../model/models';
import { COLLECTION_FORMATS }                                from '../variables';
import { Configuration }                                     from '../configuration';
import { Produitfichecontrollerv1ApiInterface }                            from './Produitfichecontrollerv1ApiInterface';
import axios                                                 from 'axios';
import {client}                                              from "webstomp-client";


export class Produitfichecontrollerv1Api implements Produitfichecontrollerv1ApiInterface {

    protected basePath = 'https://localhost';
    public defaultHeaders: {};
    public configuration: Configuration = new Configuration();

    constructor(protected http: AxiosInstance, configuration?: Configuration) {
        this.basePath = http.defaults.baseURL
        if (configuration) {
            this.configuration = configuration;
        }
    }

    private extendObj<T1, T2 extends T1>(objA: T2, objB: T2): T1|T2 {
        for(let key in objB){
            if(objB.hasOwnProperty(key)){
                objA[key] = objB[key];
            }
        }
        return objA;
    }

    private toQueryString(obj) {
        var parts = [];
        for (var i in obj) {
            if (obj.hasOwnProperty(i)) {
                parts.push(encodeURIComponent(i) + "=" + encodeURIComponent(obj[i]));
            }
        }
        return parts.join("&");
    }

    /**
     * 
     * @summary create
     * @param details details
     */
    public create(details: models.ProduitFicheDetails, extraHttpRequestParams?: any): Promise<models.ProduitFiche> {
        return new Promise<models.ProduitFiche>((resolve, reject) => {
            this.createWithHttpInfo(details, extraHttpRequestParams)
                .then(response => resolve(response.data))
                .catch(reason => reject(reason));
        });
    }

    /**
     * 
     * @summary delete
     * @param produitFicheId produitFicheId
     */
    public delete(produitFicheId: number, extraHttpRequestParams?: any): Promise<{}> {
        return new Promise<{}>((resolve, reject) => {
            this.deleteWithHttpInfo(produitFicheId, extraHttpRequestParams)
                .then(response => resolve(response.data))
                .catch(reason => reject(reason));
        });
    }

    /**
     * 
     * @summary findAll
     * @param extId extId
     * @param extSystem extSystem
     * @param dateCreee date.creee
     * @param dateModifiee date.modifiee
     */
    public findAll(extId?: string, extSystem?: string, dateCreee?: Array<string>, dateModifiee?: Array<string>, extraHttpRequestParams?: any): Promise<Array<models.ProduitFiche>> {
        return new Promise<Array<models.ProduitFiche>>((resolve, reject) => {
            this.findAllWithHttpInfo(extId, extSystem, dateCreee, dateModifiee, extraHttpRequestParams)
                .then(response => resolve(response.data))
                .catch(reason => reject(reason));
        });
    }

    /**
     * 
     * @summary findOne
     * @param produitFicheId produitFicheId
     */
    public findOne(produitFicheId: number, extraHttpRequestParams?: any): Promise<models.ProduitFiche> {
        return new Promise<models.ProduitFiche>((resolve, reject) => {
            this.findOneWithHttpInfo(produitFicheId, extraHttpRequestParams)
                .then(response => resolve(response.data))
                .catch(reason => reject(reason));
        });
    }

    /**
     * 
     * @summary getState
     * @param produitFicheId produitFicheId
     */
    public getState(produitFicheId: number, extraHttpRequestParams?: any): Promise<string> {
        return new Promise<string>((resolve, reject) => {
            this.getStateWithHttpInfo(produitFicheId, extraHttpRequestParams)
                .then(response => resolve(response.data))
                .catch(reason => reject(reason));
        });
    }

    /**
     * 
     * @summary replace
     * @param produitFicheId produitFicheId
     * @param details details
     */
    public replace(produitFicheId: number, details: models.ProduitFicheDetails, extraHttpRequestParams?: any): Promise<models.ProduitFiche> {
        return new Promise<models.ProduitFiche>((resolve, reject) => {
            this.replaceWithHttpInfo(produitFicheId, details, extraHttpRequestParams)
                .then(response => resolve(response.data))
                .catch(reason => reject(reason));
        });
    }

    /**
     * 
     * @summary update
     * @param produitFicheId produitFicheId
     * @param details details
     */
    public update(produitFicheId: number, details: models.JsonPatch, extraHttpRequestParams?: any): Promise<models.ProduitFiche> {
        return new Promise<models.ProduitFiche>((resolve, reject) => {
            this.updateWithHttpInfo(produitFicheId, details, extraHttpRequestParams)
                .then(response => resolve(response.data))
                .catch(reason => reject(reason));
        });
    }


    /**
     * create
     * 
     * @param details details
     */
    public createWithHttpInfo(details: models.ProduitFicheDetails, extraHttpRequestParams?: any): Promise<AxiosResponse> {
        const path = '/api/v1/produitFiches';

        let queryParameters = {};
        let headers = this.extendObj({}, this.defaultHeaders);;
        // verify required parameter 'details' is not null or undefined
        if (details === null || details === undefined) {
            throw new Error('Required parameter details was null or undefined when calling create.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers['Content-Type'] = 'application/json';


        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters?'?'+queryParameters:'';

        let requestOptions = {
            url: path + queryParameters,
            method: 'post',
            headers: headers,
            baseURL: this.basePath,
            data: details == null ? '' : JSON.stringify(details),
            withCredentials:this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(requestOptions);
    }

    /**
     * delete
     * 
     * @param produitFicheId produitFicheId
     */
    public deleteWithHttpInfo(produitFicheId: number, extraHttpRequestParams?: any): Promise<AxiosResponse> {
        const path = '/api/v1/produitFiches/${produitFicheId}'
                    .replace('${' + 'produitFicheId' + '}', String(produitFicheId));

        let queryParameters = {};
        let headers = this.extendObj({}, this.defaultHeaders);;
        // verify required parameter 'produitFicheId' is not null or undefined
        if (produitFicheId === null || produitFicheId === undefined) {
            throw new Error('Required parameter produitFicheId was null or undefined when calling delete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            '*/*'
        ];


        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters?'?'+queryParameters:'';

        let requestOptions = {
            url: path + queryParameters,
            method: 'delete',
            headers: headers,
            baseURL: this.basePath,
            withCredentials:this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(requestOptions);
    }

    /**
     * findAll
     * 
     * @param extId extId
     * @param extSystem extSystem
     * @param dateCreee date.creee
     * @param dateModifiee date.modifiee
     */
    public findAllWithHttpInfo(extId?: string, extSystem?: string, dateCreee?: Array<string>, dateModifiee?: Array<string>, extraHttpRequestParams?: any): Promise<AxiosResponse> {
        const path = '/api/v1/produitFiches';

        let queryParameters = {};
        let headers = this.extendObj({}, this.defaultHeaders);;
        if (extId !== undefined) {
            queryParameters['extId'] = extId;
        }

        if (extSystem !== undefined) {
            queryParameters['extSystem'] = extSystem;
        }

        if (dateCreee) {
                queryParameters['date.creee'] = [];
            dateCreee.forEach((element) => {
                queryParameters['date.creee'].push(element);
            })
        }

        if (dateModifiee) {
                queryParameters['date.modifiee'] = [];
            dateModifiee.forEach((element) => {
                queryParameters['date.modifiee'].push(element);
            })
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];


        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters?'?'+queryParameters:'';

        let requestOptions = {
            url: path + queryParameters,
            method: 'get',
            headers: headers,
            baseURL: this.basePath,
            withCredentials:this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(requestOptions);
    }

    /**
     * findOne
     * 
     * @param produitFicheId produitFicheId
     */
    public findOneWithHttpInfo(produitFicheId: number, extraHttpRequestParams?: any): Promise<AxiosResponse> {
        const path = '/api/v1/produitFiches/${produitFicheId}'
                    .replace('${' + 'produitFicheId' + '}', String(produitFicheId));

        let queryParameters = {};
        let headers = this.extendObj({}, this.defaultHeaders);;
        // verify required parameter 'produitFicheId' is not null or undefined
        if (produitFicheId === null || produitFicheId === undefined) {
            throw new Error('Required parameter produitFicheId was null or undefined when calling findOne.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];


        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters?'?'+queryParameters:'';

        let requestOptions = {
            url: path + queryParameters,
            method: 'get',
            headers: headers,
            baseURL: this.basePath,
            withCredentials:this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(requestOptions);
    }

    /**
     * getState
     * 
     * @param produitFicheId produitFicheId
     */
    public getStateWithHttpInfo(produitFicheId: number, extraHttpRequestParams?: any): Promise<AxiosResponse> {
        const path = '/api/v1/produitFiches/${produitFicheId}/etat'
                    .replace('${' + 'produitFicheId' + '}', String(produitFicheId));

        let queryParameters = {};
        let headers = this.extendObj({}, this.defaultHeaders);;
        // verify required parameter 'produitFicheId' is not null or undefined
        if (produitFicheId === null || produitFicheId === undefined) {
            throw new Error('Required parameter produitFicheId was null or undefined when calling getState.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            '*/*'
        ];


        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters?'?'+queryParameters:'';

        let requestOptions = {
            url: path + queryParameters,
            method: 'get',
            headers: headers,
            baseURL: this.basePath,
            withCredentials:this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(requestOptions);
    }

    /**
     * replace
     * 
     * @param produitFicheId produitFicheId
     * @param details details
     */
    public replaceWithHttpInfo(produitFicheId: number, details: models.ProduitFicheDetails, extraHttpRequestParams?: any): Promise<AxiosResponse> {
        const path = '/api/v1/produitFiches/${produitFicheId}'
                    .replace('${' + 'produitFicheId' + '}', String(produitFicheId));

        let queryParameters = {};
        let headers = this.extendObj({}, this.defaultHeaders);;
        // verify required parameter 'produitFicheId' is not null or undefined
        if (produitFicheId === null || produitFicheId === undefined) {
            throw new Error('Required parameter produitFicheId was null or undefined when calling replace.');
        }
        // verify required parameter 'details' is not null or undefined
        if (details === null || details === undefined) {
            throw new Error('Required parameter details was null or undefined when calling replace.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers['Content-Type'] = 'application/json';


        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters?'?'+queryParameters:'';

        let requestOptions = {
            url: path + queryParameters,
            method: 'put',
            headers: headers,
            baseURL: this.basePath,
            data: details == null ? '' : JSON.stringify(details),
            withCredentials:this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(requestOptions);
    }

    /**
     * update
     * 
     * @param produitFicheId produitFicheId
     * @param details details
     */
    public updateWithHttpInfo(produitFicheId: number, details: models.JsonPatch, extraHttpRequestParams?: any): Promise<AxiosResponse> {
        const path = '/api/v1/produitFiches/${produitFicheId}'
                    .replace('${' + 'produitFicheId' + '}', String(produitFicheId));

        let queryParameters = {};
        let headers = this.extendObj({}, this.defaultHeaders);;
        // verify required parameter 'produitFicheId' is not null or undefined
        if (produitFicheId === null || produitFicheId === undefined) {
            throw new Error('Required parameter produitFicheId was null or undefined when calling update.');
        }
        // verify required parameter 'details' is not null or undefined
        if (details === null || details === undefined) {
            throw new Error('Required parameter details was null or undefined when calling update.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
            'application/json'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers['Content-Type'] = 'application/json';


        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters?'?'+queryParameters:'';

        let requestOptions = {
            url: path + queryParameters,
            method: 'patch',
            headers: headers,
            baseURL: this.basePath,
            data: details == null ? '' : JSON.stringify(details),
            withCredentials:this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(requestOptions);
    }

}

    export class Produitfichecontrollerv1ApiVue extends Produitfichecontrollerv1Api {

        private installed = false

        constructor() {
            super(axios.create())
        }

        public registerTopicActif(callback: {(message: models.ProduitFicheActifEvent): void}): {topic: string, listener: {(message: models.ProduitFicheActifEvent): void;}} {
            return {topic: '/topic/referentiel/produit/fiche/*v1/state/actif/*', listener: callback}
        }
        public registerTopicActifFor(id: number, callback: {(message: models.ProduitFicheActifEvent): void}): {topic: string, listener: {(message: models.ProduitFicheActifEvent): void;}} {
            return {topic: '/topic/referentiel/produit/fiche/*v1/state/actif/' + id, listener: callback}
        }
        public unregisterTopicActif(): string {
            return '/topic/referentiel/produit/fiche/*v1/state/actif/*'
        }
        public unregisterTopicActifFor(id: number): string {
            return '/topic/referentiel/produit/fiche/*v1/state/actif/' + id
        }
        public registerTopicInactif(callback: {(message: models.ProduitFicheInactifEvent): void}): {topic: string, listener: {(message: models.ProduitFicheInactifEvent): void;}} {
            return {topic: '/topic/referentiel/produit/fiche/*v1/state/inactif/*', listener: callback}
        }
        public registerTopicInactifFor(id: number, callback: {(message: models.ProduitFicheInactifEvent): void}): {topic: string, listener: {(message: models.ProduitFicheInactifEvent): void;}} {
            return {topic: '/topic/referentiel/produit/fiche/*v1/state/inactif/' + id, listener: callback}
        }
        public unregisterTopicInactif(): string {
            return '/topic/referentiel/produit/fiche/*v1/state/inactif/*'
        }
        public unregisterTopicInactifFor(id: number): string {
            return '/topic/referentiel/produit/fiche/*v1/state/inactif/' + id
        }
        public registerTopicLabelMisAJour(callback: {(message: models.ProduitFicheLabelMisAJourEvent): void}): {topic: string, listener: {(message: models.ProduitFicheLabelMisAJourEvent): void;}} {
            return {topic: '/topic/referentiel/produit/fiche/*v1/update/labelMisAJour/*', listener: callback}
        }
        public registerTopicLabelMisAJourFor(id: number, callback: {(message: models.ProduitFicheLabelMisAJourEvent): void}): {topic: string, listener: {(message: models.ProduitFicheLabelMisAJourEvent): void;}} {
            return {topic: '/topic/referentiel/produit/fiche/*v1/update/labelMisAJour/' + id, listener: callback}
        }
        public unregisterTopicLabelMisAJour(): string {
            return '/topic/referentiel/produit/fiche/*v1/update/labelMisAJour/*'
        }
        public unregisterTopicLabelMisAJourFor(id: number): string {
            return '/topic/referentiel/produit/fiche/*v1/update/labelMisAJour/' + id
        }

        public buildProduitFicheDetails(): models.ProduitFicheDetails {
            return {} as models.ProduitFicheDetails;
        }
        public buildJsonPatch(): models.JsonPatch {
            return {} as models.JsonPatch;
        }


         private install(Vue, url) {

            if(Vue.topics === undefined) {
                Vue.topics = [];
                Vue.stompConnected = false;
            }

            this.basePath = url

           function addListeners() {
                for(let topic in this.$topics.myTopics) {
                    addListener(this, topic);
                }
            }
            function addListener(that, topic) {
                if(Vue.topics[topic] === undefined) {
                    Vue.topics[topic] = [];
                    tryConnect(function(sessionId) {
                        subscribeTopic(topic);
                    });
                }
                let listener = that.$topics.myTopics[topic];
                Vue.topics[topic][that._uid] = listener;
            }
            function removeListeners() {
                for(let topic in this.$topics.myTopics) {
                    removeListener(this, topic);
                }
            }
            function removeListener(that, topic) {
                let listener = that.$topics.myTopics[topic];
                delete Vue.topics[topic][that._uid]
                if(Vue.topics[topic].join('') === '') {
                    delete Vue.topics[topic];
                    unsubscribeTopic(topic);
                    if(Vue.topics.join('') === '') {
                        tryDisconnect();
                    }
                }
            }
            function subscribeTopic(topic) {
               try{
                   Vue.stompClient.subscribe(topic, function subscribeTopicCallback(body,headers){
                       console.log('This is the body of a message on the subscribed queue:', body);
                       Vue.topics[topic].forEach(listener => {
                           let res = '';
                           eval('res='+body.body)
                           listener(res);
                       });
                   });
                   console.log('subscribe topic ' + topic);
               } catch(e){
                   setTimeout(function() {
                       subscribeTopic(topic);
                   }, 1000);
               }
            }
            function unsubscribeTopic(topic) {
                console.log('unsubscribe topic ' + topic);
                Vue.stompClient.unsubscribe(topic);
            }
            function tryConnect(callback) {
                if(Vue.stompConnected) {
                    callback(Vue.stompSessionId);
                    return;
                }
                try {
                    Vue.stompClient = client(url.replace('http://', 'ws://') + '/eventsWs');
                } catch(e) {
                    console.log("Impossible de se connecter");
                    console.log(e);
                    setTimeout(function() {
                        tryConnect(function() {
                            for(let topic in Vue.topics) {
                                subscribeTopic(topic);
                            }
                        });
                    }, 2000);
                }
                Vue.stompClient.connect('guest', 'guest', function(sessionId) {
                    Vue.stompSessionId = sessionId;
                    Vue.stompConnected = true;
                    callback(sessionId);
                    console.log('connecté au STOMP ');
                }, function(error) {
                    Vue.stompConnected = false;
                    console.log('Error de connection : ' + error);
                    setTimeout(function() {
                        tryConnect(function() {
                            for(let topic in Vue.topics) {
                                subscribeTopic(topic);
                            }
                        });
                    }, 2000);
                });
            }
            function tryDisconnect() {
                if(!Vue.stompConnected) {
                    return;
                }
                Vue.stompClient.disconnect();
                Vue.stompConnected = false;
            }
            Vue.mixin({
                beforeCreate: function() {
                    this.$topics = {
                        myTopics: {},
                        subscribe: function({topic, listener}) {
                            this.myTopics[topic] = listener;
                        }
                    };
                },
                mounted: addListeners,
                beforeDestroy: removeListeners,
                methods : {
                    subscribeTopic: function({topic, listener}) {
                        this.$topics.myTopics[topic] = listener;
                        addListener(this, topic);
                    },
                    unsubscribeTopic: function(topic) {
                        removeListener(this, topic);
                    }
                }
            });
        }
    }