import { AxiosInstance, AxiosResponse } from 'axios';
import * as models from '../model/models';
import { Configuration } from '../configuration';
import { Produitfichecontrollerv1ApiInterface } from './Produitfichecontrollerv1ApiInterface';
export declare class Produitfichecontrollerv1Api implements Produitfichecontrollerv1ApiInterface {
    protected http: AxiosInstance;
    protected basePath: string;
    defaultHeaders: {};
    configuration: Configuration;
    constructor(http: AxiosInstance, configuration?: Configuration);
    private extendObj<T1, T2>(objA, objB);
    private toQueryString(obj);
    create(details: models.ProduitFicheDetails, extraHttpRequestParams?: any): Promise<models.ProduitFiche>;
    delete(produitFicheId: number, extraHttpRequestParams?: any): Promise<{}>;
    findAll(extId?: string, extSystem?: string, dateCreee?: Array<string>, dateModifiee?: Array<string>, extraHttpRequestParams?: any): Promise<Array<models.ProduitFiche>>;
    findOne(produitFicheId: number, extraHttpRequestParams?: any): Promise<models.ProduitFiche>;
    getState(produitFicheId: number, extraHttpRequestParams?: any): Promise<string>;
    replace(produitFicheId: number, details: models.ProduitFicheDetails, extraHttpRequestParams?: any): Promise<models.ProduitFiche>;
    update(produitFicheId: number, details: models.JsonPatch, extraHttpRequestParams?: any): Promise<models.ProduitFiche>;
    createWithHttpInfo(details: models.ProduitFicheDetails, extraHttpRequestParams?: any): Promise<AxiosResponse>;
    deleteWithHttpInfo(produitFicheId: number, extraHttpRequestParams?: any): Promise<AxiosResponse>;
    findAllWithHttpInfo(extId?: string, extSystem?: string, dateCreee?: Array<string>, dateModifiee?: Array<string>, extraHttpRequestParams?: any): Promise<AxiosResponse>;
    findOneWithHttpInfo(produitFicheId: number, extraHttpRequestParams?: any): Promise<AxiosResponse>;
    getStateWithHttpInfo(produitFicheId: number, extraHttpRequestParams?: any): Promise<AxiosResponse>;
    replaceWithHttpInfo(produitFicheId: number, details: models.ProduitFicheDetails, extraHttpRequestParams?: any): Promise<AxiosResponse>;
    updateWithHttpInfo(produitFicheId: number, details: models.JsonPatch, extraHttpRequestParams?: any): Promise<AxiosResponse>;
}
export declare class Produitfichecontrollerv1ApiVue extends Produitfichecontrollerv1Api {
    private installed;
    constructor();
    registerTopicActif(callback: {
        (message: models.ProduitFicheActifEvent): void;
    }): {
        topic: string;
        listener: {
            (message: models.ProduitFicheActifEvent): void;
        };
    };
    registerTopicActifFor(id: number, callback: {
        (message: models.ProduitFicheActifEvent): void;
    }): {
        topic: string;
        listener: {
            (message: models.ProduitFicheActifEvent): void;
        };
    };
    unregisterTopicActif(): string;
    unregisterTopicActifFor(id: number): string;
    registerTopicInactif(callback: {
        (message: models.ProduitFicheInactifEvent): void;
    }): {
        topic: string;
        listener: {
            (message: models.ProduitFicheInactifEvent): void;
        };
    };
    registerTopicInactifFor(id: number, callback: {
        (message: models.ProduitFicheInactifEvent): void;
    }): {
        topic: string;
        listener: {
            (message: models.ProduitFicheInactifEvent): void;
        };
    };
    unregisterTopicInactif(): string;
    unregisterTopicInactifFor(id: number): string;
    registerTopicLabelMisAJour(callback: {
        (message: models.ProduitFicheLabelMisAJourEvent): void;
    }): {
        topic: string;
        listener: {
            (message: models.ProduitFicheLabelMisAJourEvent): void;
        };
    };
    registerTopicLabelMisAJourFor(id: number, callback: {
        (message: models.ProduitFicheLabelMisAJourEvent): void;
    }): {
        topic: string;
        listener: {
            (message: models.ProduitFicheLabelMisAJourEvent): void;
        };
    };
    unregisterTopicLabelMisAJour(): string;
    unregisterTopicLabelMisAJourFor(id: number): string;
    buildProduitFicheDetails(): models.ProduitFicheDetails;
    buildJsonPatch(): models.JsonPatch;
    private install(Vue, url);
}
