"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var configuration_1 = require('../configuration');
var axios_1 = require('axios');
var webstomp_client_1 = require("webstomp-client");
var Produitfichecontrollerv1Api = (function () {
    function Produitfichecontrollerv1Api(http, configuration) {
        this.http = http;
        this.basePath = 'https://localhost';
        this.configuration = new configuration_1.Configuration();
        this.basePath = http.defaults.baseURL;
        if (configuration) {
            this.configuration = configuration;
        }
    }
    Produitfichecontrollerv1Api.prototype.extendObj = function (objA, objB) {
        for (var key in objB) {
            if (objB.hasOwnProperty(key)) {
                objA[key] = objB[key];
            }
        }
        return objA;
    };
    Produitfichecontrollerv1Api.prototype.toQueryString = function (obj) {
        var parts = [];
        for (var i in obj) {
            if (obj.hasOwnProperty(i)) {
                parts.push(encodeURIComponent(i) + "=" + encodeURIComponent(obj[i]));
            }
        }
        return parts.join("&");
    };
    Produitfichecontrollerv1Api.prototype.create = function (details, extraHttpRequestParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.createWithHttpInfo(details, extraHttpRequestParams)
                .then(function (response) { return resolve(response.data); })
                .catch(function (reason) { return reject(reason); });
        });
    };
    Produitfichecontrollerv1Api.prototype.delete = function (produitFicheId, extraHttpRequestParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.deleteWithHttpInfo(produitFicheId, extraHttpRequestParams)
                .then(function (response) { return resolve(response.data); })
                .catch(function (reason) { return reject(reason); });
        });
    };
    Produitfichecontrollerv1Api.prototype.findAll = function (extId, extSystem, dateCreee, dateModifiee, extraHttpRequestParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.findAllWithHttpInfo(extId, extSystem, dateCreee, dateModifiee, extraHttpRequestParams)
                .then(function (response) { return resolve(response.data); })
                .catch(function (reason) { return reject(reason); });
        });
    };
    Produitfichecontrollerv1Api.prototype.findOne = function (produitFicheId, extraHttpRequestParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.findOneWithHttpInfo(produitFicheId, extraHttpRequestParams)
                .then(function (response) { return resolve(response.data); })
                .catch(function (reason) { return reject(reason); });
        });
    };
    Produitfichecontrollerv1Api.prototype.getState = function (produitFicheId, extraHttpRequestParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.getStateWithHttpInfo(produitFicheId, extraHttpRequestParams)
                .then(function (response) { return resolve(response.data); })
                .catch(function (reason) { return reject(reason); });
        });
    };
    Produitfichecontrollerv1Api.prototype.replace = function (produitFicheId, details, extraHttpRequestParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.replaceWithHttpInfo(produitFicheId, details, extraHttpRequestParams)
                .then(function (response) { return resolve(response.data); })
                .catch(function (reason) { return reject(reason); });
        });
    };
    Produitfichecontrollerv1Api.prototype.update = function (produitFicheId, details, extraHttpRequestParams) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.updateWithHttpInfo(produitFicheId, details, extraHttpRequestParams)
                .then(function (response) { return resolve(response.data); })
                .catch(function (reason) { return reject(reason); });
        });
    };
    Produitfichecontrollerv1Api.prototype.createWithHttpInfo = function (details, extraHttpRequestParams) {
        var path = '/api/v1/produitFiches';
        var queryParameters = {};
        var headers = this.extendObj({}, this.defaultHeaders);
        ;
        if (details === null || details === undefined) {
            throw new Error('Required parameter details was null or undefined when calling create.');
        }
        var consumes = [
            'application/json'
        ];
        var produces = [
            'application/json'
        ];
        headers['Content-Type'] = 'application/json';
        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters ? '?' + queryParameters : '';
        var requestOptions = {
            url: path + queryParameters,
            method: 'post',
            headers: headers,
            baseURL: this.basePath,
            data: details == null ? '' : JSON.stringify(details),
            withCredentials: this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }
        return this.http.request(requestOptions);
    };
    Produitfichecontrollerv1Api.prototype.deleteWithHttpInfo = function (produitFicheId, extraHttpRequestParams) {
        var path = '/api/v1/produitFiches/${produitFicheId}'
            .replace('${' + 'produitFicheId' + '}', String(produitFicheId));
        var queryParameters = {};
        var headers = this.extendObj({}, this.defaultHeaders);
        ;
        if (produitFicheId === null || produitFicheId === undefined) {
            throw new Error('Required parameter produitFicheId was null or undefined when calling delete.');
        }
        var consumes = [];
        var produces = [
            '*/*'
        ];
        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters ? '?' + queryParameters : '';
        var requestOptions = {
            url: path + queryParameters,
            method: 'delete',
            headers: headers,
            baseURL: this.basePath,
            withCredentials: this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }
        return this.http.request(requestOptions);
    };
    Produitfichecontrollerv1Api.prototype.findAllWithHttpInfo = function (extId, extSystem, dateCreee, dateModifiee, extraHttpRequestParams) {
        var path = '/api/v1/produitFiches';
        var queryParameters = {};
        var headers = this.extendObj({}, this.defaultHeaders);
        ;
        if (extId !== undefined) {
            queryParameters['extId'] = extId;
        }
        if (extSystem !== undefined) {
            queryParameters['extSystem'] = extSystem;
        }
        if (dateCreee) {
            queryParameters['date.creee'] = [];
            dateCreee.forEach(function (element) {
                queryParameters['date.creee'].push(element);
            });
        }
        if (dateModifiee) {
            queryParameters['date.modifiee'] = [];
            dateModifiee.forEach(function (element) {
                queryParameters['date.modifiee'].push(element);
            });
        }
        var consumes = [];
        var produces = [
            'application/json'
        ];
        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters ? '?' + queryParameters : '';
        var requestOptions = {
            url: path + queryParameters,
            method: 'get',
            headers: headers,
            baseURL: this.basePath,
            withCredentials: this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }
        return this.http.request(requestOptions);
    };
    Produitfichecontrollerv1Api.prototype.findOneWithHttpInfo = function (produitFicheId, extraHttpRequestParams) {
        var path = '/api/v1/produitFiches/${produitFicheId}'
            .replace('${' + 'produitFicheId' + '}', String(produitFicheId));
        var queryParameters = {};
        var headers = this.extendObj({}, this.defaultHeaders);
        ;
        if (produitFicheId === null || produitFicheId === undefined) {
            throw new Error('Required parameter produitFicheId was null or undefined when calling findOne.');
        }
        var consumes = [];
        var produces = [
            'application/json'
        ];
        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters ? '?' + queryParameters : '';
        var requestOptions = {
            url: path + queryParameters,
            method: 'get',
            headers: headers,
            baseURL: this.basePath,
            withCredentials: this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }
        return this.http.request(requestOptions);
    };
    Produitfichecontrollerv1Api.prototype.getStateWithHttpInfo = function (produitFicheId, extraHttpRequestParams) {
        var path = '/api/v1/produitFiches/${produitFicheId}/etat'
            .replace('${' + 'produitFicheId' + '}', String(produitFicheId));
        var queryParameters = {};
        var headers = this.extendObj({}, this.defaultHeaders);
        ;
        if (produitFicheId === null || produitFicheId === undefined) {
            throw new Error('Required parameter produitFicheId was null or undefined when calling getState.');
        }
        var consumes = [];
        var produces = [
            '*/*'
        ];
        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters ? '?' + queryParameters : '';
        var requestOptions = {
            url: path + queryParameters,
            method: 'get',
            headers: headers,
            baseURL: this.basePath,
            withCredentials: this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }
        return this.http.request(requestOptions);
    };
    Produitfichecontrollerv1Api.prototype.replaceWithHttpInfo = function (produitFicheId, details, extraHttpRequestParams) {
        var path = '/api/v1/produitFiches/${produitFicheId}'
            .replace('${' + 'produitFicheId' + '}', String(produitFicheId));
        var queryParameters = {};
        var headers = this.extendObj({}, this.defaultHeaders);
        ;
        if (produitFicheId === null || produitFicheId === undefined) {
            throw new Error('Required parameter produitFicheId was null or undefined when calling replace.');
        }
        if (details === null || details === undefined) {
            throw new Error('Required parameter details was null or undefined when calling replace.');
        }
        var consumes = [
            'application/json'
        ];
        var produces = [
            'application/json'
        ];
        headers['Content-Type'] = 'application/json';
        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters ? '?' + queryParameters : '';
        var requestOptions = {
            url: path + queryParameters,
            method: 'put',
            headers: headers,
            baseURL: this.basePath,
            data: details == null ? '' : JSON.stringify(details),
            withCredentials: this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }
        return this.http.request(requestOptions);
    };
    Produitfichecontrollerv1Api.prototype.updateWithHttpInfo = function (produitFicheId, details, extraHttpRequestParams) {
        var path = '/api/v1/produitFiches/${produitFicheId}'
            .replace('${' + 'produitFicheId' + '}', String(produitFicheId));
        var queryParameters = {};
        var headers = this.extendObj({}, this.defaultHeaders);
        ;
        if (produitFicheId === null || produitFicheId === undefined) {
            throw new Error('Required parameter produitFicheId was null or undefined when calling update.');
        }
        if (details === null || details === undefined) {
            throw new Error('Required parameter details was null or undefined when calling update.');
        }
        var consumes = [
            'application/json'
        ];
        var produces = [
            'application/json'
        ];
        headers['Content-Type'] = 'application/json';
        queryParameters = this.toQueryString(queryParameters);
        queryParameters = queryParameters ? '?' + queryParameters : '';
        var requestOptions = {
            url: path + queryParameters,
            method: 'patch',
            headers: headers,
            baseURL: this.basePath,
            data: details == null ? '' : JSON.stringify(details),
            withCredentials: this.configuration.withCredentials
        };
        if (extraHttpRequestParams) {
            requestOptions = this.extendObj(requestOptions, extraHttpRequestParams);
        }
        return this.http.request(requestOptions);
    };
    return Produitfichecontrollerv1Api;
}());
exports.Produitfichecontrollerv1Api = Produitfichecontrollerv1Api;
var Produitfichecontrollerv1ApiVue = (function (_super) {
    __extends(Produitfichecontrollerv1ApiVue, _super);
    function Produitfichecontrollerv1ApiVue() {
        _super.call(this, axios_1.default.create());
        this.installed = false;
    }
    Produitfichecontrollerv1ApiVue.prototype.registerTopicActif = function (callback) {
        return { topic: '/topic/referentiel/produit/fiche/*v1/state/actif/*', listener: callback };
    };
    Produitfichecontrollerv1ApiVue.prototype.registerTopicActifFor = function (id, callback) {
        return { topic: '/topic/referentiel/produit/fiche/*v1/state/actif/' + id, listener: callback };
    };
    Produitfichecontrollerv1ApiVue.prototype.unregisterTopicActif = function () {
        return '/topic/referentiel/produit/fiche/*v1/state/actif/*';
    };
    Produitfichecontrollerv1ApiVue.prototype.unregisterTopicActifFor = function (id) {
        return '/topic/referentiel/produit/fiche/*v1/state/actif/' + id;
    };
    Produitfichecontrollerv1ApiVue.prototype.registerTopicInactif = function (callback) {
        return { topic: '/topic/referentiel/produit/fiche/*v1/state/inactif/*', listener: callback };
    };
    Produitfichecontrollerv1ApiVue.prototype.registerTopicInactifFor = function (id, callback) {
        return { topic: '/topic/referentiel/produit/fiche/*v1/state/inactif/' + id, listener: callback };
    };
    Produitfichecontrollerv1ApiVue.prototype.unregisterTopicInactif = function () {
        return '/topic/referentiel/produit/fiche/*v1/state/inactif/*';
    };
    Produitfichecontrollerv1ApiVue.prototype.unregisterTopicInactifFor = function (id) {
        return '/topic/referentiel/produit/fiche/*v1/state/inactif/' + id;
    };
    Produitfichecontrollerv1ApiVue.prototype.registerTopicLabelMisAJour = function (callback) {
        return { topic: '/topic/referentiel/produit/fiche/*v1/update/labelMisAJour/*', listener: callback };
    };
    Produitfichecontrollerv1ApiVue.prototype.registerTopicLabelMisAJourFor = function (id, callback) {
        return { topic: '/topic/referentiel/produit/fiche/*v1/update/labelMisAJour/' + id, listener: callback };
    };
    Produitfichecontrollerv1ApiVue.prototype.unregisterTopicLabelMisAJour = function () {
        return '/topic/referentiel/produit/fiche/*v1/update/labelMisAJour/*';
    };
    Produitfichecontrollerv1ApiVue.prototype.unregisterTopicLabelMisAJourFor = function (id) {
        return '/topic/referentiel/produit/fiche/*v1/update/labelMisAJour/' + id;
    };
    Produitfichecontrollerv1ApiVue.prototype.buildProduitFicheDetails = function () {
        return {};
    };
    Produitfichecontrollerv1ApiVue.prototype.buildJsonPatch = function () {
        return {};
    };
    Produitfichecontrollerv1ApiVue.prototype.install = function (Vue, url) {
        if (Vue.topics === undefined) {
            Vue.topics = [];
            Vue.stompConnected = false;
        }
        this.basePath = url;
        function addListeners() {
            for (var topic in this.$topics.myTopics) {
                addListener(this, topic);
            }
        }
        function addListener(that, topic) {
            if (Vue.topics[topic] === undefined) {
                Vue.topics[topic] = [];
                tryConnect(function (sessionId) {
                    subscribeTopic(topic);
                });
            }
            var listener = that.$topics.myTopics[topic];
            Vue.topics[topic][that._uid] = listener;
        }
        function removeListeners() {
            for (var topic in this.$topics.myTopics) {
                removeListener(this, topic);
            }
        }
        function removeListener(that, topic) {
            var listener = that.$topics.myTopics[topic];
            delete Vue.topics[topic][that._uid];
            if (Vue.topics[topic].join('') === '') {
                delete Vue.topics[topic];
                unsubscribeTopic(topic);
                if (Vue.topics.join('') === '') {
                    tryDisconnect();
                }
            }
        }
        function subscribeTopic(topic) {
            try {
                Vue.stompClient.subscribe(topic, function subscribeTopicCallback(body, headers) {
                    console.log('This is the body of a message on the subscribed queue:', body);
                    Vue.topics[topic].forEach(function (listener) {
                        var res = '';
                        eval('res=' + body.body);
                        listener(res);
                    });
                });
                console.log('subscribe topic ' + topic);
            }
            catch (e) {
                setTimeout(function () {
                    subscribeTopic(topic);
                }, 1000);
            }
        }
        function unsubscribeTopic(topic) {
            console.log('unsubscribe topic ' + topic);
            Vue.stompClient.unsubscribe(topic);
        }
        function tryConnect(callback) {
            if (Vue.stompConnected) {
                callback(Vue.stompSessionId);
                return;
            }
            try {
                Vue.stompClient = webstomp_client_1.client(url.replace('http://', 'ws://') + '/eventsWs');
            }
            catch (e) {
                console.log("Impossible de se connecter");
                console.log(e);
                setTimeout(function () {
                    tryConnect(function () {
                        for (var topic in Vue.topics) {
                            subscribeTopic(topic);
                        }
                    });
                }, 2000);
            }
            Vue.stompClient.connect('guest', 'guest', function (sessionId) {
                Vue.stompSessionId = sessionId;
                Vue.stompConnected = true;
                callback(sessionId);
                console.log('connecté au STOMP ');
            }, function (error) {
                Vue.stompConnected = false;
                console.log('Error de connection : ' + error);
                setTimeout(function () {
                    tryConnect(function () {
                        for (var topic in Vue.topics) {
                            subscribeTopic(topic);
                        }
                    });
                }, 2000);
            });
        }
        function tryDisconnect() {
            if (!Vue.stompConnected) {
                return;
            }
            Vue.stompClient.disconnect();
            Vue.stompConnected = false;
        }
        Vue.mixin({
            beforeCreate: function () {
                this.$topics = {
                    myTopics: {},
                    subscribe: function (_a) {
                        var topic = _a.topic, listener = _a.listener;
                        this.myTopics[topic] = listener;
                    }
                };
            },
            mounted: addListeners,
            beforeDestroy: removeListeners,
            methods: {
                subscribeTopic: function (_a) {
                    var topic = _a.topic, listener = _a.listener;
                    this.$topics.myTopics[topic] = listener;
                    addListener(this, topic);
                },
                unsubscribeTopic: function (topic) {
                    removeListener(this, topic);
                }
            }
        });
    };
    return Produitfichecontrollerv1ApiVue;
}(Produitfichecontrollerv1Api));
exports.Produitfichecontrollerv1ApiVue = Produitfichecontrollerv1ApiVue;
//# sourceMappingURL=Produitfichecontrollerv1Api.js.map